# Copyright Amazon.com Inc. or its affiliates. All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License"). You
# may not use this file except in compliance with the License. A copy of
# the License is located at
#
#     http://aws.amazon.com/apache2.0/
#
# or in the "license" file accompanying this file. This file is
# distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF
# ANY KIND, either express or implied. See the License for the specific
# language governing permissions and limitations under the License.

"""This module implements the central program data structure and other related structures
for AutoQASM.
"""

from .pragmas import verbatim  # noqa: F401
from .program import (  # noqa: F401
    GateArgs,
    MainProgram,
    Program,
    ProgramConversionContext,
    ProgramMode,
    ProgramScope,
    UserConfig,
    build_program,
    get_program_conversion_context,
    in_active_program_conversion_context,
)
from .serialization_properties import OpenQASMSerializationProperties  # noqa: F401
